unit UDictation;
{$define CC}

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleServer, SpeechLib_TLB, ActiveX, ComCtrls;

type
  TForm1 = class(TForm)
    SpSharedRecoContext1: TSpSharedRecoContext;
    btnStart: TButton;
    btnStop: TButton;
    Memo1: TRichEdit;
    procedure btnStartClick(Sender: TObject);
    procedure SpSharedRecoContext1Recognition(ASender: TObject;
      StreamNumber: Integer; StreamPosition: OleVariant;
      RecognitionType: TOleEnum; const Result: ISpeechRecoResult);
    procedure btnStopClick(Sender: TObject);
  private
    FGrammar: ISpeechRecoGrammar;

{$ifdef CC}
    FGrammar2: ISpeechRecoGrammar;
{$endif}

    procedure InitGrammar;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.InitGrammar;
begin
  if FGrammar = nil then
  begin
    SpSharedRecoContext1.EventInterests := SREAllEvents;
    FGrammar := SpSharedRecoContext1.CreateGrammar(0); // basic grammar

{$ifdef CC}
    FGrammar2 := SpSharedRecoContext1.CreateGrammar(1);
    FGrammar2.CmdLoadFromFile('CommandMemoFR.xml', SLODynamic);
{$endif}
  end;
end;

procedure TForm1.btnStartClick(Sender: TObject);
begin
  InitGrammar;
  FGrammar.DictationSetState(SGDSActive);

{$ifdef CC}
  FGrammar2.CmdSetRuleIdState(0, SGDSActive); // 0: for all TopLevel and Active rules in the grammar
{$endif}
end;

procedure TForm1.btnStopClick(Sender: TObject);
begin
  InitGrammar;
  FGrammar.DictationSetState(SGDSInactive);

{$ifdef CC}
  FGrammar2.CmdSetRuleIdState(0, SGDSInactive);
{$endif}
end;

procedure TForm1.SpSharedRecoContext1Recognition(ASender: TObject;
  StreamNumber: Integer; StreamPosition: OleVariant; RecognitionType: TOleEnum;
  const Result: ISpeechRecoResult);
var
  Txt: string;
begin
{$ifndef CC}
  Memo1.SelText := Result.PhraseInfo.GetText(0, -1, True); // -1 to get everything
{$else}
  Txt := Result.PhraseInfo.GetText(0, -1, True);
  case Result.PhraseInfo.GrammarId of
    0: Memo1.SelText := Txt;
    1: if SameText(Txt, 'efface memo') then
         Memo1.Text := ''
       else
       if SameText(Txt, 'select memo') then
         Memo1.SelectAll;  // Memo1.HideSelection := False;
    else
      raise Exception.Create('bad GrammarId');
  end;
{$endif}
end;

end.

