unit UReadAloud;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    btnRead: TButton;
    procedure btnReadClick(Sender: TObject);
    procedure FormClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  u_Speech;

{$R *.dfm}

// Grab the Handle of the Window under the current mouse position
function GetTheWindowHandle(bChild: Boolean = False): HWND;
var
  P: TPoint;
  H: HWND;
begin
  if GetCursorPos(P) then
  begin
    Result := WindowFromPoint(P);
    if bChild and (Result<>0)then
    begin
      while True do
      begin
        H:=ChildWindowFromPoint(Result, P);
        if (H=0) or (H=Result) then
          Break
        else
          Result:=H;
      end;
    end;
  end
  else
    Result:=0;
end;

// Get information for a Window from its handle
function GetSomeWindowText(H: HWND = 0): string;
begin
  SetLength(Result,4096);
  SetLength(Result, GetWindowText(H, PChar(Result), 4095));
 end;


procedure TForm1.btnReadClick(Sender: TObject);
var
  H: HWND;
begin
  H := GetTheWindowHandle;
  if (H = Handle) or (H = (Sender as TWinControl).Handle) then
    raise Exception.Create('Please move your cursor to another form!');
  Speak(GetSomeWindowText(H), SVSFlagsAsync)
end;

procedure TForm1.FormClick(Sender: TObject);
begin
  raise Exception.Create('Do not click on this Form');
end;

procedure SpeechExceptionHandler(Self, Sender: TObject; E: Exception);
begin
  try
    Speak(E.Message, SVSFPurgeBeforeSpeak or SVSFlagsAsync);
  except
    // Don't want any (Speech) exception during exception handling
  end;
  Application.ShowException(E);
end;

initialization
  @Application.OnException := @SpeechExceptionHandler;
//  @Application.OnException := @u_Speech.RoughSpeechExceptionHandler;

end.
