unit USpeechDemo;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, {SpeechLib_TLB,} Spin, ExtCtrls;

type
  TForm2 = class(TForm)
    Memo1: TMemo;
    btnSpeak: TButton;
    edtVolume: TSpinEdit;
    lblVolume: TLabel;
    edtRate: TSpinEdit;
    lblRate: TLabel;
    lblPitch: TLabel;
    edtPitch: TSpinEdit;
    edtC1: TLabeledEdit;
    edtC2: TLabeledEdit;
    edtVolumeC1: TSpinEdit;
    lblVolumeC1: TLabel;
    edtRateC1: TSpinEdit;
    lblRateC1: TLabel;
    lblPitchC1: TLabel;
    edtPitchC1: TSpinEdit;
    edtVolumeC2: TSpinEdit;
    lblVolumeC2: TLabel;
    edtRateC2: TSpinEdit;
    lblRateC2: TLabel;
    lblPitchC2: TLabel;
    edtPitchC2: TSpinEdit;
    btnDialog: TButton;
    chkAsync: TCheckBox;
    btnC1C2: TButton;
    btnMom: TButton;
    edtFile: TLabeledEdit;
    btnFile: TButton;
    btnDing: TButton;
    procedure FormCreate(Sender: TObject);
    procedure btnSpeakClick(Sender: TObject);
    procedure btnDialogClick(Sender: TObject);
    procedure btnC1C2Click(Sender: TObject);
    procedure btnMomClick(Sender: TObject);
    procedure btnFileClick(Sender: TObject);
    procedure btnDingClick(Sender: TObject);
  private
    { Private declarations }
//    FRate: Integer;
//    FVolume: Integer;
//    FPitch: Integer;
//    FVoice: TSpVoice;
//    FVoice: Variant;
    procedure SpeakEx(const AText: string; AVolume, ARate, APitch: integer);
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation

uses
  u_Speech, ComObj, StrUtils;

{$R *.dfm}

procedure TForm2.btnDialogClick(Sender: TObject);
var
  sl: TStringList;
  s: string;
  I: Integer;
begin
  sl := TStringList.Create;
  try
    if Memo1.SelLength > 0 then
      sl.Text := Memo1.SelText
    else
      sl.Text := Memo1.Text;
    for I := 0 to sl.Count - 1 do
    begin
      s := sl[I];       
      if SameText(edtC1.Text,Copy(sl[I], 1, Length(edtC1.Text))) then
        SpeakEx(Copy(sl[I], Length(edtC1.Text)+1, Length(sl[I])), edtVolumeC1.Value, edtRateC1.Value, edtPitchC1.Value)
      else if SameText(edtC2.Text,Copy(sl[I], 1, Length(edtC2.Text))) then
        SpeakEx(Copy(sl[I], Length(edtC2.Text)+1, Length(sl[I])), edtVolumeC2.Value, edtRateC2.Value, edtPitchC2.Value)
      else
        SpeakEx(sl[I], edtVolume.Value, edtRate.Value, edtPitch.Value);
    end;
  finally
    sl.Free;
  end;
end;

procedure TForm2.btnDingClick(Sender: TObject);
const
  // put any WAV file here
  DingFile = 'C:\Users\fgaillard\Documents\multiplication\SOUND49.WAV';
begin
  u_Speech.Speak(DingFile, SVSFIsFilename or Ord(chkAsync.Checked));
end;

procedure TForm2.btnFileClick(Sender: TObject);
begin
  u_Speech.Volume(edtVolume.Value);
  u_Speech.Rate(edtRate.Value);
  u_Speech.SpeakPitch('', edtPitch.Value, Ord(chkAsync.Checked));
  u_Speech.Speak(edtFile.Text, SVSFIsFilename or Ord(chkAsync.Checked) or SVSFIsXML);
end;

procedure TForm2.btnMomClick(Sender: TObject);
begin
  edtC1.Text := 'Mom: ';
  edtC2.Text := 'Lily: ';
  Memo1.Text :=
  'Mom: Lucie! J''ai besoin d''aide. Viens me donner un coup de main!' + sLinebreak+
  'Lily: Maman! C''est pas juste! C''est au tour de David!' + sLinebreak+
  'Mom: Viens immdiatement! Il fait ses devoirs.';
//  'Mom: Lily, come here to help me!' + sLinebreak+
//  'Lily: Mom! It''s not fair! Should be David''s turn!' + sLinebreak+
//  'Mom: Please come here immediately! He''s doing his homework.';
end;

procedure TForm2.btnSpeakClick(Sender: TObject);
begin
  u_Speech.Volume(edtVolume.Value);
  u_Speech.Rate(edtRate.Value);
  u_Speech.SpeakPitch('', edtPitch.Value, Ord(chkAsync.Checked));
  if Memo1.SelLength > 0 then
    u_Speech.Speak(Memo1.SelText, Ord(chkAsync.Checked))
  else
    u_Speech.Speak(Memo1.Text, Ord(chkAsync.Checked));
end;

procedure TForm2.btnC1C2Click(Sender: TObject);
begin
  edtC1.Text := 'C1';
  edtC2.Text := 'C2';
  Memo1.Text :=
  'C1Speech synthesis is the artificial production of human speech.'+sLinebreak+
  'C2A computer system used for this purpose is called a speech synthesizer,'+sLinebreak+
  'C1and can be implemented in software, or hardware.';
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
//  FVoice := CreateOLEObject('SAPI.SpVoice'); // as TSpVoice;
//  FVoice := TSpVoice.Create(Self); // as TSpVoice;
  btnMomClick(nil);
  edtFile.Text := 'http://fgaillard.com/download/ExempleSpeech.txt';
end;

procedure TForm2.SpeakEx(const AText: string; AVolume, ARate,
  APitch: integer);
begin
  u_Speech.Volume(AVolume);
  u_Speech.Rate(ARate);
  u_Speech.SpeakPitch(AText, APitch, Ord(chkAsync.Checked));
end;

{
Mom: Lily, come here to help me!
Lily: <emph><partofsp part="interjection">Mom!</partofsp></emph> It's not fair! Should be David's turn!
Mom: <silence msec="500"/> Please come here <emph>immediately!</emph> He's doing his homework.
}
{Mom: Lucie! J'ai besoin d'aide. Viens me donner un coup de main!
Lily: Maman! C'est pas juste! C'est au tour de David!
Mom: Viens immdiatement! Il fait ses devoirs.}

end.
